/* 
 * File:   ListNode.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a ListNode, a place to store a string through a LinkedList.
 * It also contains a pointer to the following ListNode.
 * 
 * Based on Node, which was created on January 11, 2013, 3:31 PM
 */

#ifndef LISTNODE_H
#define	LISTNODE_H

#include <stdio.h>
#include <string>

class ListNode {
public:
    //big three
    ListNode();//default constructor
    ListNode(const ListNode& orig);//copy constructor (not defined)
    virtual ~ListNode();//virtual destructor (not defined)
    
    //public utilities
    //getters and setters
    std::string getLine();
    int getNumber();
    void setLineandNumber(std::string line, int number);
    ListNode* getNext();
    void setNext(ListNode* in);
private:
    std::string _line;//line associated with number
    int _number;//the number itself
    ListNode* _next;//pointer to next node
};

#endif	/* LISTNODE_H */

