/* 
 * File:   LinkedList.h
 * Author: Will Matheson
 * Course: PROG 2400 (Data Structures), Section 700
 * Due:    March 25, 2013
 * 
 * Header file for a LinkedList. It is the means to access ListNodes that store
 * strings.
 *
 * Based on earlier LinkedList, which was created on January 11, 2013, 3:32 PM
 */

#ifndef LINKEDLIST_H
#define	LINKEDLIST_H

#include <iostream>
#include "ListNode.h"

class LinkedList {
public:
    LinkedList();//default constructor
    LinkedList(const LinkedList& orig);//copy constructor (not defined)
    virtual ~LinkedList();//virtual destructor (not defined)
    
    void Append(int in);//add a line at the end
    LinkedList* Concat(LinkedList* firstList, int pivotValue, LinkedList* secondList);
    int ValueAt(int index);
    void Delete(int index);//delete a line by its index
    void Insert(int in, int index);//insert a line at an index
    int Count();//count the stored lines
    
    //display contents of the LinkedList
    //void ShowAllLines(std::string lprefix, int lindex);
    //void ShowLines(std::string lprefix, int lindex, int lbegin, int lend);
    //this one can also be used to stream the contents into a file
    //friend std::ostream& operator<<(std::ostream& output, LinkedList& list);
private:
    ListNode* head;//start of the train
};

#endif	/* LINKEDLIST_H */

